<?php /* $Id: db_mysql.class.php,v 1.1 2004/06/09 09:00:36 marco Exp $ */

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/*
	Database abstract layer
	-----------------------
	POSTGRESQL VERSION
	-----------------------
	A generic database layer providing a set of low to middle level functions
	originally written for WEBO project, see webo source for "real life" usages
*/

if (!defined('SM_PATH')) { define('SM_PATH','../'); }

class db_psql {
	var $connection = null;
	var $results = null;
	//var $AppUI = null;
	var $log_query = true;
	var $logged_queries = "";

	function db_psql(){
	    global $addrbook_dsn;
	    $cfg = array();
	    preg_match('/^(.+):\/\/(.+):(.+)\@(.+)\/(.+)$/',$addrbook_dsn, $match);
	    $cfg['dbhost_psql'] = $match[4];
	    $cfg['dbname_psql'] = $match[5];
	    $cfg['dbuser_psql'] = $match[2];
	    $cfg['dbpass'] = $match[3];
	    $this->db_connect( $cfg['dbhost_psql'], $cfg['dbname_psql'],$cfg['dbuser_psql'], $cfg['dbpass'], "", true );
	}

	function db_connect( $host='localhost', $dbname, $user='', $passwd='', $port='5432', $persist=false ) {
	    function_exists( 'pg_connect' )
		or  die( 'FATAL ERROR: PostgreSQL support not avaiable.  Please check your configuration.' );

            if ($persist) {
                $this->connection = & pg_pconnect( "host='$host' port='$port' dbname='$dbname' user='$user' password='$passwd'" )
                    or die( 'FATAL ERROR: Connection to database server failed' );
            } else {
                $this->connection = & pg_connect( "host='$host' port='$port' dbname='$dbname' user='$user' password='$passwd'" )
                    or die( 'FATAL ERROR: Connection to database server failed' );
            }
	    $this->logged_queries .= "connection established !<br>";
	}

	function db_error() {
	    return pg_last_error( $this->connection );
	}
	
	function db_query( $sql ) {
	    if ($this->log_query) {
		$this->logged_queries .= "$sql<br>";
	    }
	    $this->results = pg_query( $this->connection, $sql );
	    if ( $this->results ) { 
		return $this->results; 
	    }
	    return false;
	}
	
	function db_free_result( ) {
		pg_free_result( $this->results );
		unset($this->results);
		return true;
	}
	
	function db_num_rows(  ) {
		return pg_num_rows($this->results);
	}
	
	function db_fetch_row( ) {
		return pg_fetch_row( $this->results );
	}
	
	function db_fetch_assoc( ) {
		return pg_fetch_assoc( $this->results);
	}
	
	function db_fetch_array(   ) {
		return pg_fetch_array( $this->results);
	}
	
	function db_show_tables($name=null,$like=0) {
		$this->AppUI->setMsg("db_psql.class.php: db_show_table not implemented!"); 
	}
	
	function db_fetch_object(  ) {
		return pg_fetch_object( $this->results );
	}
	
	function db_escape( $str ) {
		return pg_escape_string( $str );
	}
	
}
?>