<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/
   
/**
 * abook_get_user.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * $Id: abook_get_user.php,v 1.3 2004/06/09 09:00:36 marco Exp $
 */

if (!defined('SM_PATH')) { define('SM_PATH','../'); }
   
require_once( SM_PATH . 'database/db_connect.class.php' );
   
class abook_get_user {
    var $btype = 'local';
    var $bname = 'database';
      
    var $dsn       = '';
    var $table     = '';
    var $owner     = '';
    var $dbh       = false;
      
    var $writeable = true;
      
    /* Constructor */
    function abook_get_user($user_mail) {
	global $addrbook_dsn, $addrbook_table_user;
        if (!empty($user_mail)) {
            
            $this->dsn   = $addrbook_dsn;
            $this->table = $addrbook_table_user;
            $this->owner = $user_mail;
            $this->open(true);
        } else {
            return $this->set_error('Invalid argument to constructor');
        }
    }
            
    /* Open the database. New connection if $new is true */
    function open($new = false) {
        $this->error = '';
         
        /* Return true is file is open and $new is unset */
        if ($this->dbh && !$new) { return true; }
         
        /* Close old file, if any */
        if ($this->dbh) { $this->close(); }
	$dbh = & new db_connect();
         
        if ($dbh->error) {
            return $this->set_error(sprintf(_("Database error: %s"),$dbh->error));
        }
         
        $this->dbh = $dbh;
        return true;
    }

    function set_error($string) {
        $this->error = '[' . $this->sname . '] ' . $string;
        return false;
    }

    /* Close the file and forget the filehandle */
    function close() { $this->dbh = false; }

    function get_username() {
        $ret = array();
        if(!$this->open()) { return false; }
	$colonna = $this->dbh->db_quotename("utente");
	$table = $this->dbh->db_quotename($this->table);
	$where1 = $this->dbh->db_quotename("Email");
	$where2 = $this->dbh->db_quotename("tipo");
        $query = sprintf("SELECT %s FROM %s WHERE %s='%s' AND %s=2", $colonna, $table, $where1, $this->owner, $where2);
	$res = $this->dbh->db_loadResult($query);

        return $res;
    }

    function get_list_username() {
        $ret = array();
        if(!$this->open()) { return false; }

	$colonna = $this->dbh->db_quotename("Email");
	$table = $this->dbh->db_quotename($this->table);
	$where1 = $this->dbh->db_quotename("tipo");
         
        $query = sprintf("SELECT %s FROM %s WHERE %s=2",$colonna , $table, $where1);
	$ret = $this->dbh->db_loadColumn($query);

	if ($ret == null) {
            return $this->set_error(sprintf(_("Database error: %s"),$this->dbh->error));
        }

        return $ret;
    }

} /* End of class abook_database */

?>
