<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * read_body.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This file is used for reading the msgs array and displaying
 * the resulting emails in the right frame.
 *
 * $Id: read_body.php,v 1.5 2004/02/09 08:55:26 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');


function findNextMessage($passed_id,$show_num) {
    global $msort, $msgs, $sort,
           $thread_sort_messages, $allow_server_sort,
           $server_sort_array;
    if (!is_array($server_sort_array)) {
        $thread_sort_messages = 0;
        $allow_server_sort = FALSE;
    }
    $result = -1;
    if ($thread_sort_messages || $allow_server_sort) {
        $count = count($server_sort_array) - 1;
	$nmsg=0;
        foreach($server_sort_array as $key=>$value) {
	    $nmsg++;
            if ($passed_id == $value) {
                if ($key == $count) {
                    break;
                }
                $result = $server_sort_array[$key + 1];
                break; 
            }
        }
    } else {
        if (is_array($msort)) {
	    $nmsg=0;
            for (reset($msort); ($key = key($msort)), (isset($key)); next($msort)) {
		$nmsg++;
                if ($passed_id == $msgs[$key]['ID']) {
                    next($msort);
                    $key = key($msort);
                    if (isset($key)){
                        $result = $msgs[$key]['ID'];
                        break;
                    }
                }
            }
        }
    }
    if ($result && $show_num != "999999") {
	$pos = (floor($nmsg / $show_num) * $show_num) + 1;
    } else {
	$pos = 1;
    }	
    return (array($result,$pos));
}

/** returns the index of the previous message from the array. */
function findPreviousMessage($numMessages, $passed_id,$show_num) {
    global $msort, $sort, $msgs,
           $thread_sort_messages,
           $allow_server_sort, $server_sort_array;
    $result = -1;
    if (!is_array($server_sort_array)) {
        $thread_sort_messages = 0;
        $allow_server_sort = FALSE;
    }
    if ($thread_sort_messages || $allow_server_sort ) {
	$nmsg=0;
        foreach($server_sort_array as $key=>$value) {
	    $nmsg++;
            if ($passed_id == $value) {
                if ($key == 0) {
                    break;
                }
                $result = $server_sort_array[$key - 1];
                break;
            }
        }
    } else {
        if (is_array($msort)) {
	    $nmsg=0;
            for (reset($msort); ($key = key($msort)), (isset($key)); next($msort)) {
		$nmsg++;
                if ($passed_id == $msgs[$key]['ID']) {
                    prev($msort);
                    $key = key($msort);
                    if (isset($key)) {
                        $result = $msgs[$key]['ID'];
                        break;
                    }
                }
            }
        }
    }
    if ($result && $show_num != "999999") {
	if (($nmsg-1) % $show_num == 0) {
	    $pos = ((floor($nmsg / $show_num)-1) * $show_num) + 1;
	} else {
	    $pos = (floor(($nmsg-1) / $show_num) * $show_num) + 1;
	}
    } else {
	$pos = 1;
    }	
    return (array($result,$pos));
}

/**
 * Displays a link to a page where the message is displayed more
 * "printer friendly".
 */
function printer_friendly_link($mailbox, $passed_id, $passed_ent_id, $color) {
    global $javascript_on, $base_uri;

    $params = '?passed_ent_id=' . urlencode($passed_ent_id) .
              '&mailbox=' . urlencode($mailbox) .
              '&passed_id=' . urlencode($passed_id);

    $print_text = _("View Printable Version");

    $result = '';
    /* Output the link. */
    if ($javascript_on) {
        $result = '<script language="javascript" type="text/javascript">' . "\n" .
                  '<!--' . "\n" .
                  "  function printFormat() {\n" .
                  '    window.open("'.$base_uri.'src/printer_friendly_main.php' .
                  $params . '","Print","width=800,height=600");' . "\n".
                  "  }\n" .
                  "// -->\n" .
                  "</script>\n" .
                  "<a href=\"javascript:printFormat();\">".codeHTML($print_text)."</a>\n";
    } else {
        $result = '<a target="_blank" href="'.$base_uri.'src/printer_friendly_bottom.php' .
                  "$params\">".codeHTML($print_text)."</a>\n";
    }
    return $result;
}

function ServerMDNSupport($read) {
    /* escaping $ doesn't work -> \x36 */    
    $ret = preg_match('/(\x36MDNSent|\\\\\*)/i', $read);
    return $ret;
}

function SendMDN ( $mailbox, $passed_id, $sender, $message, $imapConnection) {
    global $username, $attachment_dir, 
           $version, $attachments, $squirrelmail_language, $default_charset,
           $languages, $useSendmail, $domain, $sent_folder,
           $popuser, $data_dir, $username;

    sqgetGlobalVar('SERVER_NAME', $SERVER_NAME, SQ_SERVER);

    $header = $message->rfc822_header;
    $hashed_attachment_dir = getHashedDir($username, $attachment_dir);

    $rfc822_header = new Rfc822Header();
    $content_type  = new ContentType('multipart/report');
    $content_type->properties['report-type']='disposition-notification';

    set_my_charset();
    if ($default_charset) {
        $content_type->properties['charset']=$default_charset;
    }
    $rfc822_header->content_type = $content_type;
    $rfc822_header->to[] = $header->dnt;
    $rfc822_header->subject = _("Read:") . ' ' . encodeHeader($header->subject);

    // FIX ME, use identity.php from SM 1.5. Change this also in compose.php

    $reply_to = '';
    if (isset($identity) && $identity != 'default') {
        $from_mail = getPref($data_dir, $username, 
                             'email_address' . $identity);
        $full_name = getPref($data_dir, $username, 
                             'full_name' . $identity);
        $from_addr = '"'.$full_name.'" <'.$from_mail.'>';
        $reply_to  = getPref($data_dir, $username, 
                             'reply_to' . $identity);
    } else {
        $from_mail = getPref($data_dir, $username, 'email_address');
        $full_name = getPref($data_dir, $username, 'full_name');
        $from_addr = '"'.$full_name.'" <'.$from_mail.'>';
        $reply_to  = getPref($data_dir, $username,'reply_to');
    }

    // Patch #793504 Return Receipt Failing with <@> from Tim Craig (burny_md)
    // This merely comes from compose.php and only happens when there is no
    // email_addr specified in user's identity (which is the startup config)
    if (ereg("^([^@%/]+)[@%/](.+)$", $username, $usernamedata)) {
       $popuser = $usernamedata[1];
       $domain  = $usernamedata[2];
       unset($usernamedata);
    } else {
       $popuser = $username;
    }

    if (!$from_mail) {
       $from_mail = "$popuser@$domain";
       $from_addr = $from_mail;
    }

    $rfc822_header->from = $rfc822_header->parseAddress($from_addr,true);
    if ($reply_to) {
       $rfc822_header->reply_to = $rfc822_header->parseAddress($reply_to,true);
    }

    // part 1 (RFC2298)
    $senton = getLongDateString( $header->date );
    $to_array = $header->to;
    $to = '';
    foreach ($to_array as $line) {
        $to .= ' '.$line->getAddress();
    }
    $now = getLongDateString( time() );
    set_my_charset();
    $body = _("Your message") . "\r\n\r\n" .
            "\t" . _("To:") . ' ' . decodeHeader($to,false,false) . "\r\n" .
            "\t" . _("Subject:") . ' ' . decodeHeader($header->subject,false,false) . "\r\n" .
            "\t" . _("Sent:") . ' ' . $senton . "\r\n" .
            "\r\n" .
            sprintf( _("Was displayed on %s"), $now );

    $special_encoding = '';
    if (isset($languages[$squirrelmail_language]['XTRA_CODE']) && 
        function_exists($languages[$squirrelmail_language]['XTRA_CODE'])) {
        $body = $languages[$squirrelmail_language]['XTRA_CODE']('encode', $body);
        if (strtolower($default_charset) == 'iso-2022-jp') {
            if (mb_detect_encoding($body) == 'ASCII') {
                $special_encoding = '8bit';
            } else {
                $body = mb_convert_encoding($body, 'JIS');
                $special_encoding = '7bit';
            }
        }
    }
    $part1 = new Message();
    $part1->setBody($body);
    $mime_header = new MessageHeader;
    $mime_header->type0 = 'text';
    $mime_header->type1 = 'plain';
    if ($special_encoding) {
        $mime_header->encoding = $special_encoding;
    } else {
        $mime_header->encoding = 'us-ascii';
    }
    if ($default_charset) {
        $mime_header->parameters['charset'] = $default_charset;
    }
    $part1->mime_header = $mime_header;

    // part2  (RFC2298)
    $original_recipient  = $to;
    $original_message_id = $header->message_id;

    $report = "Reporting-UA : $SERVER_NAME ; OverLook (version $version) \r\n";
    if ($original_recipient != '') {
        $report .= "Original-Recipient : $original_recipient\r\n";
    }
    $final_recipient = $sender;
    $report .= "Final-Recipient: rfc822; $final_recipient\r\n" .
              "Original-Message-ID : $original_message_id\r\n" .
              "Disposition: manual-action/MDN-sent-manually; displayed\r\n";

    $part2 = new Message();
    $part2->setBody($report);
    $mime_header = new MessageHeader;
    $mime_header->type0 = 'message';
    $mime_header->type1 = 'disposition-notification';
    $mime_header->encoding = 'us-ascii';
    $part2->mime_header = $mime_header;

    $composeMessage = new Message();
    $composeMessage->rfc822_header = $rfc822_header;
    $composeMessage->addEntity($part1);
    $composeMessage->addEntity($part2);


    if ($useSendmail) {
        require_once(SM_PATH . 'class/deliver/Deliver_SendMail.class.php');
        global $sendmail_path;
        $deliver = new Deliver_SendMail();
        $stream = $deliver->initStream($composeMessage,$sendmail_path);
    } else {
        require_once(SM_PATH . 'class/deliver/Deliver_SMTP.class.php');
        $deliver = new Deliver_SMTP();
        global $smtpServerAddress, $smtpPort, $smtp_auth_mech, $pop_before_smtp;
		if ($smtp_auth_mech == 'none') {
			$user = '';
			$pass = '';
		} else {
            global $key, $onetimepad;
            $user = $username;
            $pass = OneTimePadDecrypt($key, $onetimepad);
        }
        $authPop = (isset($pop_before_smtp) && $pop_before_smtp) ? true : false;
        $stream = $deliver->initStream($composeMessage,$domain,0,
                                       $smtpServerAddress, $smtpPort, $user, $pass, $authPop);
    }
    $success = false;
    if ($stream) {
        $length  = $deliver->mail($composeMessage, $stream);
        $success = $deliver->finalizeStream($stream);
    }
    if (!$success) {
        $msg  = codeHTML($deliver->dlv_msg) . '<br>' .
                codeHTML(_("Server replied")) .": ". codeHTML($deliver->dlv_ret_nr) . ' '.
                codeHTML($deliver->dlv_server_msg);
        require_once(SM_PATH . 'functions/display_messages.php');
        plain_error_message(codeHTML($msg), $color);
    } else {
        unset ($deliver);
        if (sqimap_mailbox_exists ($imapConnection, $sent_folder)) {
            sqimap_append ($imapConnection, $sent_folder, $length);
            require_once(SM_PATH . 'class/deliver/Deliver_IMAP.class.php');
            $imap_deliver = new Deliver_IMAP();
            $imap_deliver->mail($composeMessage, $imapConnection);
            sqimap_append_done ($imapConnection);
            unset ($imap_deliver);
        }
    }
    return $success;
}

function ToggleMDNflag ($set ,$imapConnection, $mailbox, $passed_id, $uid_support) {
    $sg   =  $set?'+':'-';
    $cmd  = 'STORE ' . $passed_id . ' ' . $sg . 'FLAGS ($MDNSent)';
    $read = sqimap_run_command ($imapConnection, $cmd, true, $response, 
                                $readmessage, $uid_support);
}

function ClearAttachments() {
    global $username, $attachments, $attachment_dir;

    $hashed_attachment_dir = getHashedDir($username, $attachment_dir);

    $rem_attachments = array();
    if (isset($attachments)) {
	foreach ($attachments as $info) {
    	    if ($info['session'] == -1) {
        	$attached_file = "$hashed_attachment_dir/$info[localfilename]";
        	if (file_exists($attached_file)) {
            	    unlink($attached_file);
        	}
    	    } else {
        	$rem_attachments[] = $info;
    	    }
	}
    }
    $attachments = $rem_attachments;
}

function formatRecipientString($recipients, $item ) {
    $string = '';
    if ((is_array($recipients)) && (isset($recipients[0]))) {
        if (count($recipients) == 1) {
            $string .= decodeHeader($recipients[0]->getAddress(true));
	} else {
	    $new_option = array();
    	    foreach($recipients as $r) { 
		$v = decodeHeader($r->getAddress(true));
		$new_option[$v] = $v; 
	    }
	    $string .= addSelect('list'.$item, $new_option, '', TRUE, 'class="list_read_body"',1);
	}
    }
    return $string;
}

function formatMenuBar($mailbox, $passed_id, $passed_ent_id, $message, $mbx_response,$where,$what,$show_num) {
    
    global $base_uri, $draft_folder, $where, $what, $color, $sort,
           $startMessage, $PHP_SELF, $save_as_draft, $compose_width, $compose_height,
           $enable_forward_as_attachment;

    $topbar_delimiter = '&nbsp;|&nbsp;';
    $urlMailbox = urlencode($mailbox);


    sqgetGlobalVar('QUERY_STRING', $query_string, SQ_SERVER);
    $params = 'passed_ent_id=' . $passed_ent_id .
              '&mailbox=' . urlencode($mailbox) .
              '&passed_id=' . $passed_id; 
    $js = "var id_message='".$query_string."';\n";
    $js .= "var id_message_print='".$params."';\n";
    $js = "\n".'<script language="JavaScript" type="text/javascript">' . $js . "\n</script>\n";
    //END JAVASCRIPT

    $s = $js;
    $s .= '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/new_window.js"></script>'."\n";
    $s .= '<table width="100%" cellpadding="3" HEIGHT="100%" cellspacing="0" align="center"'.
         ' border="0" class="titlemsg"><tr>';

    $s .= html_tag( 'td', '', 'left', '', 'width="33%"' ) . '<small>';

    $comp_uri = $base_uri.'src/compose.php' .
                '?passed_id=' . $passed_id .
                '&mailbox=' . $urlMailbox .
                '&startMessage=' . $startMessage .
		(isset($passed_ent_id)?'&passed_ent_id='.urlencode($passed_ent_id):'');

    // START REPLY
    $comp_action_uri = $comp_uri . '&smaction=reply';
    $s .= makeComposeLink($comp_action_uri, _("Reply"));
    // END REPLY

    // START FORWARD
    $comp_action_uri = $comp_uri . '&smaction=forward';
    $s .= $topbar_delimiter;
    $s .= makeComposeLink($comp_action_uri, _("Forward"));
    // END FORWARD

    // START EDIT AS NEW o RESUME DRAFT

    if (($mailbox == $draft_folder) && ($save_as_draft)) {
        $comp_alt_uri = $comp_uri . '&smaction=draft';
        $comp_alt_string = _("Resume Draft");
    } else if (handleAsSent($mailbox)) {
        $comp_alt_uri = $comp_uri . '&smaction=edit_as_new';
        $comp_alt_string = _("Edit Message as New");
    }
    if (isset($comp_alt_uri)) {
        $s .= $topbar_delimiter;
	$s .= makeComposeLink($comp_alt_uri, $comp_alt_string);
    }
    // END EDIT AS NEW o RESUME DRAFT
    $s .= '</small></td>'; 

    $s .= '<td align="center" width="33%"><small>';
    //START TASTI NEXT/PREVIEW
    if ($where && $what) {
        $searchstr = '&where='.$where.'&what='.$what;
    } else {
	$searchstr = '';
    }
    if (!(isset($where) && isset($what)) && !$passed_ent_id) {
        $b = findPreviousMessage($mbx_response['EXISTS'], $passed_id, $show_num);
	$prev=$b[0];
	$ntsp=$b[1];
        $a = findNextMessage($passed_id,$show_num);
	$next=$a[0];
	$ntsn=$a[1];
        if ($prev != -1) {
	    if ($startMessage == $ntsp) {
        	$s .= '<a href="javascript:parent.SelectMessage('.$prev.',\'read_body.php?mailbox='.$urlMailbox.'&passed_id='.$prev. '&startMessage='.$startMessage.$searchstr.'\')">'.codeHTML(_("Previous")).'</a>';       
	    } else {
        	$s .= '<a href="javascript:parent.SelectMessage('.$prev.',\'read_body.php?mailbox='.$urlMailbox.'&passed_id='.$prev. '&startMessage='.$ntsp.$searchstr.'\',\'right_main.php?mailbox='.$urlMailbox.'&passed_id='.$prev. '&startMessage='.$ntsp.$searchstr.'\')">'.codeHTML(_("Previous")).'</a>';       
	    }
        } else {
            $s .= '<span class="disabled">'.codeHTML(_("Previous")).'</span>';
        }
        $s .= $topbar_delimiter;
        if ($next != -1) {
	    if ($startMessage == $ntsn) {
        	$s .= '<a href="javascript:parent.SelectMessage('.$next.',\'read_body.php?mailbox='.$urlMailbox.'&passed_id='.$next. '&startMessage='.$startMessage.$searchstr.'\')">'.codeHTML(_("Next")).'</a>';       
	    } else {
        	$s .= '<a href="javascript:parent.SelectMessage('.$next.',\'read_body.php?mailbox='.$urlMailbox.'&passed_id='.$next. '&startMessage='.$ntsn.$searchstr.'\',\'right_main.php?mailbox='.$urlMailbox.'&passed_id='.$next. '&startMessage='.$ntsn.$searchstr.'\')">'.codeHTML(_("Next")).'</a>';       
	    }
        } else {
            $s .= '<span class="disabled">'.codeHTML(_("Next")).'</span>';
        }
    } else if (isset($passed_ent_id) && $passed_ent_id) {
        /* code for navigating through attached message/rfc822 messages */
        $url = set_url_var($PHP_SELF, 'passed_ent_id',0);
        $s .= '<a href="'.$url.'">'.codeHTML(_("View Message")).'</a>';
        $entities     = array();
        $entity_count = array();
        $c = 0;
        foreach($message->parent->entities as $ent) {
            if ($ent->type0 == 'message' && $ent->type1 == 'rfc822') {
                $c++;
                $entity_count[$c] = $ent->entity_id;
                $entities[$ent->entity_id] = $c;
            }
        }
        $prev_link = codeHTML(_("Previous"));
        $next_link = codeHTML(_("Next"));
        if($entities[$passed_ent_id] > 1) {
            $prev_ent_id = $entity_count[$entities[$passed_ent_id] - 1];
            $prev_link   = '<a href="'
                         . set_url_var($PHP_SELF, 'passed_ent_id', $prev_ent_id)
                         . '">' . $prev_link . '</a>';
        }
        if($entities[$passed_ent_id] < $c) {
            $next_ent_id = $entity_count[$entities[$passed_ent_id] + 1];
            $next_link   = '<a href="'
                         . set_url_var($PHP_SELF, 'passed_ent_id', $next_ent_id)
                         . '">' . $next_link . '</a>';
        }
        $s .= $topbar_delimiter . $prev_link;
        $par_ent_id = $message->parent->entity_id;
        if ($par_ent_id) {
            $par_ent_id = substr($par_ent_id,0,-2);
            $s .= $topbar_delimiter;
            $url = set_url_var($PHP_SELF, 'passed_ent_id',$par_ent_id);
            $s .= '<a href="'.$url.'">'.codeHTML(_("Up")).'</a>';
        }
        $s .= $topbar_delimiter . $next_link;
    }
    //END TASTI NEXT/PREVIEW
    $s .= '</small></td>' . "\n";

    $s .= html_tag( 'td', '', 'right', '', 'width="33%" nowrap' ) . '<small>';

    // START REPLY ALL
    $comp_action_uri = $comp_uri . '&smaction=reply_all';
    $s .= makeComposeLink($comp_action_uri, _("Reply All"));
    // END REPLY ALL

    // START FORWARD AS ATTACHMENT
    if ($enable_forward_as_attachment) {
        $comp_action_uri = $comp_uri . '&smaction=forward_as_attachment';
        $s .= $topbar_delimiter;
	$s .= makeComposeLink($comp_action_uri, _("Forward as Attachment"));
    }
    // END FORWARD AS ATTACHMENT

    $s .= '</small></td>';
    $s.= '</tr></table>';

///    $ret = concat_hook_function('read_body_menu_top', $s);
//    if($ret != '') { $s = $ret; }
    echo $s;
//    do_hook('read_body_menu_bottom');
}


function formatEnvheader($mailbox, $passed_id, $passed_ent_id, $message, $color, $FirstTimeSee) {

    global $msn_user_support, $default_use_mdn, $default_use_priority, $show_html_default,
           $show_xmailer_default, $mdn_user_support, $PHP_SELF, $javascript_on, $max_char_obj_d,
	   $squirrelmail_language, $base_uri, $HTTP_USER_AGENT, $custom_css;

    $header = $message->rfc822_header;
    $env = array();
    $subject = decodeHeader($header->subject);
    $subject = decodeHTML($subject);
    $subject = processSubject($subject, 0,$max_char_obj_d);
    $env[_("Subject")] = codeHTML($subject);

    $from_name = $header->getAddr_s('from');
    if (!$from_name) {
        $from_name = $header->getAddr_s('sender');
        if (!$from_name) {
            $from_name = _("Unknown sender");
        }
    }
    if ($from_name && $from_name != _("Unknown sender")) {
	if (preg_match('/"/',$from_name)) {
	    preg_match('/"(.+)" (.+)/',$from_name,$match);
	    $env[_("Sender_name")] = $match[1];
	    $env[_("Sender")] = $match[2];
	} else  if (preg_match('/@/',$from_name)) {
	    $env[_("Sender")] = $from_name; 
	} else {
	    $env[_("Sender_name")] = $from_name;  
	}
    }
    if ($env[_("Sender")]) {
	$env[_("Sender")] = preg_replace('/</','',$env[_("Sender")]);
	$env[_("Sender")] = preg_replace('/>/','',$env[_("Sender")]);
    }
    $env[_("From")] = decodeHeader($from_name);
    $env[_("To")] = formatRecipientString($header->to, "to");
    $env[_("Cc")] = formatRecipientString($header->cc, "cc");
    $env[_("Bcc")] = formatRecipientString($header->bcc, "bcc");
    if ($default_use_mdn) {
        if ($mdn_user_support) {
            if ($header->dnt) {
                if ($message->is_mdnsent) {
                    $env[_("Read receipt")] = _("sent");
                } else {
                    $env[_("Read receipt")] = _("requested"); 
                    if (!(handleAsSent($mailbox) || 
                          $message->is_deleted ||
                          $passed_ent_id)) {
                        $mdn_url = $PHP_SELF . '&sendreceipt=1';
                        if ($FirstTimeSee && $javascript_on) {
                            $script  = '<script language="JavaScript" type="text/javascript">' . "\n";
                            $script .= '<!--'. "\n";
                            $script .= 'if(window.confirm("' .
                                       jsspecialchars(_("The message sender has requested a response to indicate that you have read this message. Would you like to send a receipt?")).
                                       '")) {  '."\n" .
                                       '    sendMDN()'.
                                       '}' . "\n";
                            $script .= '// -->'. "\n";
                            $script .= '</script>'. "\n";
                            echo $script;
                        }
                        $env[_("Read receipt")] .= '&nbsp;<a href="'.$mdn_url.'">[' .
                                                   _("Send read receipt now") . ']</a>';
                    }
                }
            }
        }
    }

    if ($show_html_default && $show_html_default == 1) {
	$ent_ar = $message->findDisplayEntity(array());
    } else {
	$ent_ar = $message->findDisplayEntity(array(), array('text/plain'));
    }
    echo '<TABLE WIDTH="100%" HEIGHT="100%" CLASS="titlemsg" CELLPADDING="0" CELLSPACING="0" BORDER="0" ALIGN="center">';
    echo '<TR>';
    if (!isset($env[_("Sender_name")])) { $env[_("Sender_name")]=""; }
    echo '<TD align="left" nowrap=1><B>'.codeHTML(_("From")).':</B>&nbsp;'.$env[_("From")].'&nbsp;
	    <A HREF="#" ONCLICK="parent.new_win_overlook(\'viewinfo\',\''.$base_uri.'src/take_contact.php?sender='.urlencode($env[_("Sender")]).'&sender_name='.urlencode($env[_("Sender_name")]).'\',400,560,1,200,100);">
	    <IMG SRC="'.$base_uri.'images/'.$custom_css.'/address_small.gif" ALT="'._("Add the sender address to addressbook").'" BORDER=0></A>';
    if (isset($env[_("Read receipt")])) {
	echo '&nbsp;<b>'.codeHTML(_("Read receipt")).':&nbsp;</b>'.$env[_("Read receipt")];
    }
    echo '</td>';

    do_hook('read_body_header');

    if ($message->getAttachments($ent_ar)) {
	echo '<TD class="titlemsgattach" rowspan="3" width="1%" align="right" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'titlemsgattach\'" valign="middle">
	    <A HREF="#" ONCLICK="parent.new_win_overlook(\'attachment\',\''.$base_uri.'src/list_attachment.php?mailbox='.urlencode($mailbox).'&passed_id='.$passed_id.'\',450,150,1,300,300);">
	    <IMG SRC="'.$base_uri.'images/'.$custom_css.'/big-attach.gif" ALT="'._("The message contains attachments").'" BORDER=0></A>';
    } else {
	echo '<TD class="titlemsgattach" rowspan="3" width="1%" align="right" valign="middle">&nbsp;';
    }
    echo '</TD>';
    echo '</TR><TR>';
    echo addForm('#', 'POST', 'f'.$item);
    echo '<TD align="left" nowrap=1><B>'.codeHTML(_("To")).':</B>&nbsp;'.$env[_("To")].'&nbsp;';
    if ($env[_("Cc")]) {
	echo '<B>'.codeHTML(_("Cc")).':</B>&nbsp;'.$env[_("Cc")].'&nbsp;';
    }
    if ($env[_("Bcc")]) {
	echo '<B>'.codeHTML(_("Bcc")).':</B>&nbsp;'.$env[_("Bcc")].'';
    }
    echo '</TD></FORM></TR><TR>';
    echo '<TD align="left"><B>'.codeHTML(_("Subject")).':</B>&nbsp;'.$env[_("Subject")].'</td>';
    echo '</TR></TABLE>';
}

?>
