<?PHP
/*
 * Notify SquirrelMail Plugin
 *
 * Provides a minimal new mail notification page that will restore from
 * minimized in Javascript supporting browsers.
 *
 * Unfortunately this plugin requires Javascript on the browser.
 *
 * By Richard Gee (richard.gee@pseudocode.co.uk)
 *
 * Version 1.3
 * Copyright 2002 Pseudocode Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

 /* $Id: setup.php,v 1.8 2004/06/01 13:39:51 marco Exp $ */

define('SM_PATH','../../');

/* SquirrelMail required files. */
include_once(SM_PATH . 'plugins/filters/filters.php');    
include_once(SM_PATH . 'functions/global.php');    

global $icon_folder, $custom_css;

define('SMOPT_MODE_DISPLAY', 'display');
define('SMOPT_MODE_SUBMIT', 'submit');
define('SMOPT_MODE_LINK', 'link');
 
define('SMOPT_PAGE_MAIN', 'main');
define('SMOPT_PAGE_PERSONAL', 'personal');
define('SMOPT_PAGE_DISPLAY', 'display');
define('SMOPT_PAGE_HIGHLIGHT', 'highlight');
define('SMOPT_PAGE_FOLDER', 'folder');
define('SMOPT_PAGE_ORDER', 'order');

/*
 * Set this to true if you have problems -- check the README file
 * Note:  This doesn't work all of the time (No idea why)
 *        Seems to be related to UW
 */
global $UseSeparateImapConnection, $mailbox;
$UseSeparateImapConnection = false;
 
// set hooks for panel frame folders
function squirrelmail_plugin_init_overlook() {
    global $squirrelmail_plugin_hooks;

    $squirrelmail_plugin_hooks['icon_folder']['overlook'] = 'icon_folder';
    $squirrelmail_plugin_hooks['icon_plus_minus']['overlook'] = 'icon_plus_minus';

    $squirrelmail_plugin_hooks['left_main_before']['overlook'] = 'start_filters';
    $squirrelmail_plugin_hooks['rename_or_delete_folder']['overlook'] = 'update_for_folder';
    $squirrelmail_plugin_hooks['webmail_bottom']['overlook'] = 'start_filters';

    $squirrelmail_plugin_hooks['read_body_bottom']['overlook'] = 'read_body_bottom_overlook';
    $squirrelmail_plugin_hooks['friendly_body_bottom']['overlook'] = 'read_body_bottom_overlook';

    $squirrelmail_plugin_hooks['message_body']['overlook']     = 'get_uuencode_message_body';
    $squirrelmail_plugin_hooks['decode_body']['overlook']      = 'get_uuencode_decode_body';

    $squirrelmail_plugin_hooks['attachment application/ms-tnef']['overlook'] = 'attachment_tnef_link';

    $squirrelmail_plugin_hooks['right_main_after_header']['overlook'] = 'right_main_after_header_overlook';

    $squirrelmail_plugin_hooks['special_mailbox']['overlook'] = 'user_special_mailboxes_check';
}

// add icons folder
function icon_folder($args) {
    global $base_uri, $custom_css;
    $line=$args[0];
    $mailbox=$args[1];
    $folder_img = '';
    if ($mailbox == "INBOX") {
        $folder_img = $base_uri.'images/'.$custom_css.'/mailbox-inbox.gif';
    } else if ($mailbox == "Sent") {
        $folder_img =  $base_uri.'images/'.$custom_css.'/mailbox-sent.gif';
    } else if ($mailbox == "Trash") {
        $folder_img =  $base_uri.'images/'.$custom_css.'/mailbox-trash.gif';
    } else if ($mailbox == "Drafts") {
        $folder_img =  $base_uri.'images/'.$custom_css.'/mailbox-draft.gif';
    } else { $folder_img =  $base_uri.'images/'.$custom_css.'/mailbox.gif'; }
    $line .= '<img src="'.$folder_img.'" border=0>&nbsp;';
    return($line);
}

// add icons plus/minus
function icon_plus_minus($args) {
    global $base_uri, $custom_css;  
    $line=$args[0];
    $flag=$args[1];
    if ($flag == 1) {
	$line .= '<img src="'.$base_uri.'images/'.$custom_css.'/plus.gif" border=0 width=7 height=7>';
    } else if ($flag == 0) {
	$line .= '<img src="'.$base_uri.'images/'.$custom_css.'/minus.gif" border=0 width=7 height=7>';
    }
    return($line);
}

function right_main_after_header_overlook($mailbox) {
    global $sent_folder;
    if ($mailbox[1][0] == 'INBOX' || $mailbox[1][0] == $sent_folder) {
        start_filters($mailbox[1][0]);
    }
}

function get_uuencode_message_body (&$data) {
    include_once(SM_PATH .'plugins/get_uuencode/get_uuencode.php');
    get_uuencode_body($data);
}
 
function get_uuencode_read_body_bottom () {
    include_once(SM_PATH . 'plugins/get_uuencode/get_uuencode.php');
    get_uuencode_link();
}
 
function get_uuencode_decode_body ($encoding) {
    include_once(SM_PATH . 'plugins/get_uuencode/get_uuencode.php');
    return get_uuencode_check_encoding($encoding);
}

function attachment_tnef_link(&$Args) {
    include_once(SM_PATH .'plugins/attachment_tnef/functions.php');
    attachment_tnef_link_do($Args);
}
 
function read_body_bottom_overlook() {
    get_uuencode_read_body_bottom();
}

function user_special_mailboxes_check($box) {
    global $data_dir, $username;
    $boxnum = 0;
    while ($mailbox = getPref($data_dir, $username, 'user_special_mailboxes' . $boxnum++)) {
	if ($mailbox == $box || preg_match("/$mailbox/",$box) ) { return 1; }
    }
    return 0;
}

?>