<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

define('SM_PATH','../');    

require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

displayHtmlHeader( _("Addressbook"), '' );

sqgetGlobalVar('base_uri', $base_uri, SQ_SESSION );  

sqgetGlobalVar('where', $where, SQ_GET);
if (!$where) { $where = "A"; }

$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];

if($abook->localbackend == 0) {
    plain_error_message(
        codeHTML(_("No personal address book is defined. Contact administrator.")),
        $color);
    exit();
}

$alist = $gabook->list_addr(-1,1);
if(!is_array($alist)) {
    plain_error_message(codeHTML($gabook->error), $color);
    exit;
}
function alistcmpoverlookgroup($a,$b) {
    return (strtolower($a['group_name']) > strtolower($b['group_name'])) ? 1 : -1;
}

usort($alist,'alistcmpoverlookgroup');

    echo "\n".'<script language="JavaScript" type="text/javascript">document.folder_selected_old = 2</script>'."\n";

    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/addressbook_contact.js"></script>'."\n";
    echo '<script language="javascript" type="text/javascript" src="'.$base_uri.'js/addressbook_popup.js"></script>'."\n";

    $id = 1;
    echo '<body onload="InitContact(); self.focus();">'."\n";
    echo '<table width="100%" height="100%" border=0 cellpadding=0 cellspacing=1 valign="top" align="left">';

    echo '<tr><td height="7%" valign="top">';
    echo "\n<table height=\"100%\" cellpadding=\"2\" cellspacing=\"1\" border=\"0\">";
    echo "\n<tr>";
    echo '<td class="nav" align="right">&nbsp;</td>';
    if ($where == 'groups') {
        $selected="class=\"selected\"";
    } else {
        $selected="class=\"nav\"";
   }
    echo '<td width="1%" nowrap=1 name="folder'.$id.'"  id="folder'.$id.'" '.$selected.'><a target="ifabook" onClick="SelectedLink('.$id.',\'groups\')" href="'.$base_uri.'src/addressbook_popup_iframe.php?where=groups">' . codeHTML(_('Groups')) .'</a></td>';
    $id++;
    for ($c=65; $c < 91; $c++) {
        $cu = chr( $c );
        /**contorno per lettera di ricerca selezionata*/
        if ($where == $cu) {
            $selected="class=\"selected\"";
        } else {
            $selected="class=\"nav\"";
        }               
        echo "\n\t<td nowrap=1 width=\"1%\" name=\"folder$id\"  id=\"folder$id\"  $selected><a onClick=\"SelectedLink($id,'$cu')\" href='#'>".codeHTML($cu)."</a></td>";
	$id++;
    }
    if ($where == 'number') {
        $selected="class=\"selected\"";
    } else {
        $selected="class=\"nav\"";
    }
    echo '<td width="1%" nowrap=1 name="folder'.$id.'"  id="folder'.$id.'" '.$selected.'><a onClick="SelectedLink('.$id.',\'number\')" href="#">[0-9]</a></td>';
    $id++;
    if ($where == 'ALL') {
        $selected="class=\"selected\"";
    } else {
        $selected="class=\"nav\"";
    }
    echo '<td width="1%" nowrap=1 name="folder'.$id.'"  id="folder'.$id.'" '.$selected.'><a onClick="SelectedLink('.$id.',\'ALL\')" href="#">' . codeHTML(_('All')) .'</a></td>';
    echo "\n</tr>\n</table>";
    echo '</td></tr>';

    echo '<tr><td height="7%" valign="top">';
    echo "\n<table height=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
    echo "\n<tr>";
    echo addForm($base_uri.'src/addressbook_popup_iframe.php', 'POST', 'ffilter','','','','ifabook');
    echo addHidden('where', $where);
    echo '<td nowrap=1 width="1%" class="nav" align="left">'.codeHTML(_("Filters")).':</td>';
    echo '<td nowrap=1 class="nav" align="left">';

    $new_option['ALL'] = array('value' => _("All Addresses"), 'class' => 'privatecontact'); 
    while(list($undef,$row) = each($alist)) {   
	if ($row['source'] == _("Global group address book")) {
	    $new_option['2;'.$row['group_id']] = array('value' => '[['.$row['group_name'].']]', 'class' => 'globalcontact'); 
	} else {
	    $new_option['1;'.$row['group_id']] = array('value' => '['.$row['group_name'].']', 'class' => 'privatecontact'); 
	}
    }
    echo addSelect('filter_group', $new_option, '', TRUE, 'onChange="document.ffilter.submit();" style="width:200px" size="1" id="filter_group"');

    echo '</td>';
    echo '</form>';

    echo addForm($base_uri.'src/addressbook_popup_iframe.php', 'POST', 'fsearch','','','','ifabook');
    echo addHidden('where', 'ALL');
    echo '<td nowrap=1 class="nav" align="right">';
	echo addInput('nsearch', '', '', '', 'width="200px"');
    echo '</td>';
    echo '<td nowrap=1 width="1%" class="nav" align="right">';
	echo addButton(_("Search All Addresses"), '', '','SelectedLink('.$id.',"ALL",1);','fsearch','',1);
    echo '</td>';
    echo '</form>';

    echo '</tr></table>';
    echo '</td></tr>';

    echo '<tr><td valign="top" width="100%" height="80%">';
    echo '<table height="100%" width="100%" border=0 cellpadding=0 cellspacing=0 valign="top" align="left">';
    echo addForm($base_uri.'src/addressbook_popup.php', 'POST', 'f');
	echo '<tr>';
	    echo '<td colspan=3 class="nav">'.codeHTML(_("Select a name from the list:")).'</td>';
	echo '</tr>';
	echo '<tr>';
	    echo '<td width="35%" class="nav" valign="top" rowspan=3>';
		echo '<iframe class="nav" name="ifabook" scrolling="no" frameborder="0" style="width:98%;height:98%;" src="'.$base_uri.'src/addressbook_popup_iframe.php?where='.$where.'"></iframe>';
	    echo '</td>';
	    echo '<td class="nav">';
		echo '<table width="100%" border=0 cellpadding=3 class="border" cellspacing=0 valign="middle" align="center">';
		    echo '<tr>';
			echo '<td align="center" nowrap=1 class="nav" onclick="RemoveContact(\'send_to\');" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">&lt;--</td>';
			echo '<td align="center" nowrap=1 class="nav">'.codeHTML(_("To:")).'</td>';
			echo '<td align="center" nowrap=1 class="nav" onclick="AddContact(\'send_to\',0);" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">--&gt;</td>';
		    echo '</tr>';
		echo '</table>';
	    echo '</td>';
	    echo '<td class="nav" width="35%">';
		echo addSelect('send_to', array(), '', TRUE, 'multiple=1 style="width:200px" size="5" id="send_to"');
	    echo '</td>';
	echo '</tr>';
	echo '<tr>';
	    echo '<td class="nav" >';
		echo '<table width="100%" border=0 cellpadding=3 class="border" cellspacing=0 valign="middle" align="center">';
		    echo '<tr>';
			echo '<td align="center" nowrap=1 class="nav" onclick="RemoveContact(\'send_to_cc\');" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">&lt;--</td>';
			echo '<td align="center" nowrap=1 class="nav">'.codeHTML(_("CC:")).'</td>';
			echo '<td align="center" nowrap=1 class="nav" onclick="AddContact(\'send_to_cc\',0);" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">--&gt;</td>';
		    echo '</tr>';
		echo '</table>';
	    echo '</td>';
	    echo '<td width="35%" class="nav">';
		echo addSelect('send_to_cc', array(), '', TRUE, 'multiple=1 style="width:200px" size="5" id="send_to_cc"');
	    echo '</td>';
	echo '</tr>';
	echo '<tr>';
	    echo '<td class="nav">';
		echo '<table width="100%" border=0 cellpadding=3 class="border" cellspacing=0 valign="middle" align="center">';
		    echo '<tr>';
			echo '<td align="center" nowrap=1 class="nav" onclick="RemoveContact(\'send_to_bcc\');" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">&lt;--</td>';
			echo '<td align="center" nowrap=1 class="nav">'.codeHTML(_("BCC:")).'</td>';
			echo '<td align="center" nowrap=1 class="nav" onclick="AddContact(\'send_to_bcc\',0);" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'">--&gt;</td>';
		    echo '</tr>';
		echo '</table>';
	    echo '</td>';
	    echo '<td width="35%" class="nav">';
		echo addSelect('send_to_bcc', array(), '', TRUE, 'multiple=1 style="width:200px" size="5" id="send_to_bcc"');
	    echo '</td>';
        echo '</tr></table>';
    echo '</td></tr>';
    echo '<tr><td valign="top" width="100%" height="6%">';
    echo '<table height="100%" width="100%" border=0 cellpadding=0 cellspacing=0 valign="top" align="left">';
	echo '<tr>';
	    echo '<td valign="middle" align="center" colspan=3 class="nav">';
		echo addButton(_("Cancel"), '', '', 'self.close();','f','',1,1);
		echo '&nbsp;&nbsp;&nbsp;';
		echo addButton(_("Confirm"), '', '','SubmitIt(); self.close();','f','',1,1);
	    echo '</td>';
	echo '</tr>';
    echo '</form></table>';
    echo '</td></tr></table>';
echo '</body></html>';
?>