<?php

/********************************************************************
 *   Autori:             Marco Colombo (marco@openit.it)
 *                       Valentina Portolan (valentina@openit.it)
 *                       Giuliano Natali Diaolin (diaolin@openit.it)
 *  Copyright:           Open It S.r.l.
 *                       Viale Dante, 78
 *                       38057 Pergine Valsugana (TN) ITALY
 *                       Tel: +39 0461 534800 Fax: +39 0461 538443
 *********************************************************************/

/**
 * addressbook.php
 *
 * Copyright (c) 1999-2003 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Manage personal address book.
 *
 * $Id: view_info_group.php,v 1.1 2004/05/31 14:19:49 marco Exp $
 */

/* Path for SquirrelMail required files. */
define('SM_PATH','../');

/* SquirrelMail required files. */
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'functions/global.php');
require_once(SM_PATH . 'functions/display_messages.php');
require_once(SM_PATH . 'functions/addressbook.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/html.php');
require_once(SM_PATH . 'functions/forms.php');

sqgetGlobalVar('base_uri',  $base_uri,      SQ_SESSION);
sqgetGlobalVar('delimiter', $delimiter,     SQ_SESSION);
sqgetGlobalVar('sel',       $sel,           SQ_GET);

/************************************************
* View address                       		*
*************************************************/

displayHtmlHeader( _("Addressbook"), '' );    

global $fieldarraygroupabook; 

/* Open addressbook, with error messages on but without LDAP (the *
 * second "true"). Don't need LDAP here anyway                    */
$book = addressbook_init(true, true);
$abook = $book[0];
$gabook = $book[1];

if($gabook->localbackend == 0) {
    plain_error_message(
        codeHTML(_("No personal group address book is defined. Contact administrator.")),
        $color);
    exit();
} else if (isset($sel)) {
    list($ebackend, $enick) = explode(':', $sel);
    $data = $gabook->lookup_id($enick, $ebackend);
    $private_contacts = array();
    $public_contacts = array();
    if ($data['group_list_private']) {
        $private_contacts = $abook->lookup_group_id($data['group_list_private'], 1);
    }
    if ($data['group_list_public']) {
        $public_contacts = $abook->lookup_group_id($data['group_list_public'], 2);
    }
    $contacts = array_merge($public_contacts,$private_contacts);
    echo '<table width="100%" height="100%" class="border" cellpadding=2 cellspacing=1 border=0>';
    echo addForm($base_uri.'src/addressbook_group.php', 'POST', 'f');
    echo '<tr>';
        echo '<td height="1%" width="40%" class="nav">'.codeHTML(_("Group name:")).'</td>';
        echo '<td height="1%" width="60%" class="nav">'.codeHTML($data['group_name']).'</td>';
    echo '</tr>';
        echo '<tr>';
	    echo '<td colspan=2 class="nav" align="center">';
		$new_option = array();
                foreach ($contacts as $k => $v) {
		    if (preg_match('/^2;/',$k)) {
			$new_option[$k] = array('class' => 'globalcontact', 'value' => $v);
		    } else {
			$new_option[$k] = array('class' => 'privatecontact', 'value' => $v);
		    }
                }
		echo addSelect('group_el', $new_option, '', TRUE, 'multiple=1 style="width:98%;height:98%" id="group_el"');
            echo '</td>';
        echo '</tr>';
    echo '<tr>';
	echo '<td height="1%" align="center" onmouseover="this.className=\'navclicked\'" onmouseout="this.className=\'nav\'" colspan=2 width="20%" onclick="self.close()" class="nav">'.codeHTML(_("Close")).'</td>';
    echo '</tr>';    
    echo '</form>';
    echo '</table>';
}

echo "</BODY></HTML>\n";

?>